local init = PlayerCamera.init
function PlayerCamera:init(unit)
	init(self, unit)
	self._tp_camera_object = World:create_camera()
	self._tp_camera_object:set_near_range(3)
	self._tp_camera_object:set_far_range(250000)
	self._tp_camera_object:set_fov(75)
	self._tp_camera_object:link(self._camera_object)
	
	local cam_rot = self._camera_object:rotation()
	self._tp_camera_object:set_position(self._camera_object:position() - cam_rot:y() * 80 + Vector3(0,0,30))
	
	self._vp:set_camera(self._tp_camera_object)
end
function PlayerCamera:set_FOV(fov_value)
	self._camera_object:set_fov(fov_value)
	self._tp_camera_object:set_fov(fov_value)
end
local set_position = PlayerCamera.set_position
function PlayerCamera:set_position(pos)
	if managers.player.goat:is_ragdoll() then
		pos = managers.player.goat:get_body_position()
	end
	set_position(self, pos)
end
local set_rotation = PlayerCamera.set_rotation
function PlayerCamera:set_rotation(rot)
	set_rotation(self, rot)
	managers.player.goat:set_rotation(rot)
end