Goat = Goat or class()
Goat.HEIGHT = Vector3(0,0,60)
Goat.MASS_CENTER = 50
Goat.TONGUE_LENGTH = 100
Goat.TONGUE_MLENGTH = 1000
Goat.ANIM_DATA = {
	anim_walk_fwd = {0,1},
	anim_back = {0,1},
	anim_right_strafe = {0,1},
	anim_left_strafe = {0,1},
	anim_sprint = {0,1},
	startup = {0,1},
	anim_attack_head = {0.7,2},
	anim_attack_feet = {1.1,2},
}
function Goat:init()
	self.brush = Draw:brush(Color(0.8, 220/255, 20/255, 60/255))
	self._rot_p = 0
end
function Goat:update(t, dt)
end
function Goat:unit()
	return self._unit
end
function Goat:spawn_unit(parent)
	local goat = World:spawn_unit( Idstring( "units/pd2_dlc_peta/characters/wld_goat_1/wld_goat_1" ), parent:position(), Rotation() )
	goat:set_slot(2)
	parent:link(parent:orientation_object():name(), goat, goat:orientation_object():name())
	self._unit = goat
end
function Goat:delete_unit()
	if self:unit_alive() then
		World:delete_unit(self._unit)
	end
end
function Goat:unit_alive()
	if alive(self._unit) then
		return true
	end
end
function Goat:set_rotation(rot)
	if self:can_walk() then
		self._unit:set_rotation(Rotation(rot:yaw(), 0, rot:roll()))
	end
end
function Goat:get_body_position()
	if self:unit_alive() then
		return self._unit:body(0):position() + Vector3(0,0,20)
	end
end

function Goat:stop_sound()
	if not self:unit_alive() then
		return
	end
	self._unit:sound_source():stop()
end
function Goat:play_seq(seq)
	if not self:unit_alive() then
		return
	end
	--self._unit:sound_source():stop()
	self._unit:damage():run_sequence_simple(seq)
end
function Goat:anim_leng(anim)
	local d = Goat.ANIM_DATA[anim]
	return d and d[1]
end
function Goat:anim_type(anim)
	local d = Goat.ANIM_DATA[anim]
	return d and d[2]
end
--
function Goat:set_rotation(rot)
	if self:can_walk() then
		self._unit:set_rotation(Rotation(rot:yaw(), self._rot_p, rot:roll()))
		local plr_rot = managers.player:player_unit():movement():m_head_rot()
		local p_rot = Rotation(plr_rot:yaw(), 0, plr_rot:roll())
		self._unit:set_position(managers.player:player_unit():position() - p_rot:z() * (math.cos(self._rot_p) * Goat.MASS_CENTER - Goat.MASS_CENTER) + p_rot:y() * math.sin(self._rot_p) * Goat.MASS_CENTER)
	end
end
function Goat:set_pitch(p)
	self._rot_p = p % 360
end
function Goat:add_pitch(p)
	self._rot_p = (self._rot_p + p) % 360
end
function Goat:pitch()
	return self._rot_p
end
--
function Goat:can_walk()
	if alive(self._unit) and not self._ragdoll then
		return true
	end
end
function Goat:ragdoll_velocity()
	local vel = self._unit:body(7):velocity()
	return mvector3.length(vel)
end
function Goat:update_ragdoll_velocity(vel)
	if self:ragdoll_velocity() < vel then
		self:revive()
	end
end
function Goat:is_ragdoll()
	return self._ragdoll
end
function Goat:switch_ragdoll()
	if not self:unit_alive() then
		return
	end
	if self:is_ragdoll() then
		self:revive()
	else
		self:ragdoll()
	end
end
function Goat:switch_ragdoll_vel()
	if not self:unit_alive() then
		return
	end
	if self:is_ragdoll() then
		self:update_ragdoll_velocity(50)
	else
		self:ragdoll()
	end
end
function Goat:ragdoll()
	if self._ragdoll then
		return
	end
	self._ragdoll = true
	self:play_seq("switch_to_ragdoll")
	self:play_seq("state_interaction_disabled")
	self:stop_sound()
	self._unit:sound_source(Idstring("snd")):post_event("goat_says_meh_loop")
	
	self:set_pitch(0)
	
	local player_unit = managers.player:player_unit()
	if alive(player_unit) then
		managers.player:warp_to(player_unit:position(), Rotation())
	end
end
function Goat:revive()
	for i = 0, self._unit:num_bodies() - 1 do
		self._unit:body(i):set_enabled(i < 2)
	end
	self:play_seq("state_vis_show")
	self:play_seq("startup")
	self._ragdoll = false
	self:drop()
	
	local player_unit = managers.player:player_unit()
	if alive(player_unit) then
		player_unit:movement():set_position(self._unit:body(0):position())
	end
end
--
function Goat:grab(col_ray)
	local body = col_ray.body
	self._grab_t = {unit = col_ray.unit, body = body, offset = (col_ray.position - body:position()):rotate_with(body:rotation():inverse())}
	self._grab = true
end
function Goat:drop()
	self._grab_t = nil
	self._grab = false
end
function Goat:grabbing()
	return self._grab
end
local function get_mass(body)
	local total_mass = 0
	for i = 0, body:unit():num_bodies() - 1 do
		total_mass = total_mass + body:unit():body(i):mass()
	end
	return total_mass
end
function Goat:update(t, dt)
	if self._grab_t then
		local grab_unit = self._grab_t.unit
		local grab_body = self._grab_t.body
		if not alive(grab_unit) then
			self:drop()
			return
		end
		
		local tongue = self._unit:body(2)
		local t_pos = tongue:position()
		local grab_pos = grab_body:position() + self._grab_t.offset:rotate_with(grab_body:rotation())
		local distance = mvector3.distance(t_pos, grab_pos)
		
		if distance > Goat.TONGUE_LENGTH then
			local force_ragdoll = get_mass(grab_body) > (get_mass(tongue) + 400)
			if force_ragdoll then
				self:ragdoll()
			end	
			local body = force_ragdoll and tongue or grab_body
			local body_mass = math.min(10000, get_mass(body)) / 100
			local rot = Rotation:look_at(force_ragdoll and t_pos or grab_pos, force_ragdoll and grab_pos or t_pos, Vector3(0, 0, 1))
			local mvec1 = Vector3()
			mrotation.x(rot:y(), mvec1)
			mvector3.multiply(mvec1, 0.25)
			mvector3.add(mvec1, rot:y())
			mvector3.add(mvec1, math.UP / 2)
			mvector3.multiply(mvec1, math.min(distance, 500))
			body:push_at(body_mass, mvec1, force_ragdoll and t_pos or grab_pos)
		end
		
		local rot = Rotation:look_at(t_pos, grab_pos, Vector3(0, 0, 1))
		self.brush:box(t_pos + (grab_pos - t_pos) / 2, rot:x() * 2, rot:y() * distance / 2, rot:z() * 0.5)
	end
end

local init = PlayerManager.init
function PlayerManager:init()
	init(self)
	self.goat = Goat:new()
end