PlayerStandard.MOVER_STAND = Idstring("duck")
local init = PlayerStandard.init
function PlayerStandard:init(unit)
	init(self, unit)
	self._slotmask_bullet_impact_targets = self._slotmask_bullet_impact_targets - 2
	if self._unit:mover() then
		self._unit:kill_mover()
		self:_activate_mover(PlayerStandard.MOVER_STAND)
	end
end
local update = PlayerStandard.update
function PlayerStandard:update(t, dt)
	update(self, t, dt)
	managers.player.goat:update(t, dt)
end
local _get_input = PlayerStandard._get_input
function PlayerStandard:_get_input(t, dt)
	local input = _get_input(self, t, dt)
	if managers.player.goat:is_ragdoll() then
		for i,v in pairs(input)do
			if v and (i == "btn_primary_attack_state") then
				managers.player.goat:update_ragdoll_velocity(2)
			end
			if i ~= "btn_weapon_gadget_press" and i ~= "btn_melee_press" then
				input[i] = false
			end
		end
	end
	return input
end
local enter = PlayerStandard.enter
function PlayerStandard:enter(state_data, enter_data)
	enter(self, state_data, enter_data)
	managers.player.goat:stop_sound()
	managers.player.goat:revive()
	local state = managers.player:current_state()
	if state == "bleed_out" or state == "fatal" or state == "incapacitated" then
		managers.player.goat:play_seq("anim_sleeping")
	elseif state == "arrested" or state == "tased" then
		managers.player.goat:play_seq("anim_hanging_scaffold")
	elseif state == "driving" then
		managers.player.goat:play_seq("anim_idle_korv")
	elseif state == "jerry1" then
		managers.player.goat:play_seq("anim_hang_fan")
	elseif state == "jerry2" then
		managers.player.goat:play_seq("anim_hang_lamp")
	else
		managers.player.goat:play_seq("startup")
	end
end
local _stance_entered = PlayerStandard._stance_entered
function PlayerStandard:_stance_entered(unequipped)
	local def = self._state_data.ducking
	self._state_data.ducking = true
	_stance_entered(self, unequipped)
	self._state_data.ducking = def
end
function PlayerStandard:goat_play_anim(anim, t)
	if managers.player.goat:anim_type(self._last_anim_goat) ~= managers.player.goat:anim_type(anim) then
		local len = managers.player.goat:anim_leng(self._last_anim_goat) or 0
		if self._anim_start_t_goat and (self._anim_start_t_goat + len) > t then
			return
		end
	end
	managers.player.goat:play_seq(anim)
	self._last_anim_goat = anim
	self._anim_start_t_goat = t
end
function PlayerStandard:goat_get_move_dir()
	if not self._move_dir then
		return
	end
	local fwd_new = managers.player.goat:unit():rotation():y()
	local right_new = fwd_new:cross(math.UP)
	local walk_dir_flat = self._move_dir:with_z(0)
	mvector3.normalize(walk_dir_flat)
	local fwd_dot = walk_dir_flat:dot(fwd_new)
	local right_dot = walk_dir_flat:dot(right_new)
	if math.abs(fwd_dot) > math.abs(right_dot) then
		return fwd_dot > 0 and "f" or "b"
	else
		return right_dot > 0 and "r" or "l"
	end
end
local _determine_move_direction = PlayerStandard._determine_move_direction
function PlayerStandard:_determine_move_direction()
	_determine_move_direction(self)
	if managers.player.goat:is_ragdoll() then
		if self._move_dir then
			managers.player.goat:update_ragdoll_velocity(2)
		end
		self._move_dir = nil
		self._normal_move_dir = nil
	end
end
local _update_movement = PlayerStandard._update_movement
function PlayerStandard:_update_movement(t, dt)
	_update_movement(self, t, dt)
	if not managers.player.goat:can_walk() then
		return
	end
	local anim_side
	if self._last_velocity_xy then
		local fwd_new = managers.player.goat:unit():rotation():y()
		local right_new = fwd_new:cross(math.UP)
		local walk_dir_flat = self._last_velocity_xy:with_z(0)
		mvector3.normalize(walk_dir_flat)
		local fwd_dot = walk_dir_flat:dot(fwd_new)
		local right_dot = walk_dir_flat:dot(right_new)
		if math.abs(fwd_dot + 0.1) > math.abs(right_dot) then
			anim_side = fwd_dot > 0 and "anim_walk_fwd" or "anim_back"
		else
			anim_side = right_dot > 0 and "anim_right_strafe" or "anim_left_strafe"
		end
		local vel_len = mvector3.length(self._last_velocity_xy)
		if vel_len > 400 and anim_side == "anim_walk_fwd" then
			anim_side = "anim_sprint"
		elseif vel_len < 1 then
			anim_side = "startup"
		end
	end

	if self._last_anim_goat ~= anim_side then
		self:goat_play_anim(anim_side, t)
	end
end
--
local _update_foley = PlayerStandard._update_foley
function PlayerStandard:_update_foley(t, input)
	_update_foley(self, t, input)
	if not self._state_data.in_air and managers.player.goat:pitch() ~= 0 then
		local o = 10
		local p = managers.player.goat:pitch()
		if o < p and (360 - o) > p then
			managers.player.goat:ragdoll()
		end
		managers.player.goat:set_pitch(0)
	end
end
--flip
function PlayerStandard:_check_action_steelsight(t, input)
	local new_action
	if input.btn_steelsight_state and self._state_data.in_air and self._move_dir then
		local fwd_new = self._ext_movement:m_head_rot():y()
		local walk_dir_flat = self._move_dir:with_z(0)
		mvector3.normalize(walk_dir_flat)
		local fwd_dot = walk_dir_flat:dot(fwd_new)
		if fwd_dot ~= 0 then
			local p = (fwd_dot > 0) and -1 or 1
			managers.player.goat:add_pitch(p * 1)
		end
	end
	return new_action
end

--headbutt
function PlayerStandard:goat_attack_damage(t)
	self._state_data.meleeing = nil
	local feet = self._state_data.melee_feet
	self._state_data.melee_feet = nil
	if not managers.player.goat:can_walk() then
		return
	end
	local range = feet and 300 or 200
	local from = managers.player.goat:unit():position() + Goat.HEIGHT
	local to = from + managers.player.goat:unit():rotation():y() * range * (feet and -1 or 1)
	local sphere_cast_radius = 35
	local col_ray = self._unit:raycast("ray", from, to, "slot_mask", self._slotmask_bullet_impact_targets, "sphere_cast_radius", sphere_cast_radius, "ray_type", "body melee")
	if col_ray then
		local damage = feet and 1000 or 500
		col_ray.sphere_cast_radius = sphere_cast_radius
		local hit_unit = col_ray.unit
		managers.game_play_central:play_impact_flesh({col_ray = col_ray})
		managers.game_play_central:play_impact_sound_and_effects({
			col_ray = col_ray,
			no_decal = true,
			no_sound = true
		})
		if hit_unit:damage() and col_ray.body:extension() and col_ray.body:extension().damage then
			col_ray.body:extension().damage:damage_melee(self._unit, col_ray.normal, col_ray.position, col_ray.ray, damage)
			if hit_unit:id() ~= -1 then
				managers.network:session():send_to_peers_synched("sync_body_damage_melee", col_ray.body, self._unit, col_ray.normal, col_ray.position, col_ray.ray, damage)
			end
		end
		local character_unit, shield
		if hit_unit:in_slot(8) and alive(hit_unit:parent()) then
			character_unit = hit_unit:parent()
			shield = hit_unit
		end
		character_unit = character_unit or hit_unit
		if character_unit:character_damage() and character_unit:character_damage().damage_melee then
			local dmg_multiplier = 1
			local action_data = {}
			action_data.variant = "melee"
			action_data.damage = damage * dmg_multiplier
			action_data.damage_effect = damage
			action_data.attacker_unit = self._unit
			action_data.col_ray = col_ray
			action_data.name_id = "fists"
			action_data.charge_lerp_value = 0
			local defense_data = CopDamage.damage_melee(character_unit:character_damage(), action_data)--character_unit:character_damage():damage_melee(action_data)
			if character_unit:movement()._active_actions[1] and character_unit:movement()._active_actions[1]:type() == "hurt" then
				character_unit:movement()._active_actions[1]:force_ragdoll()
			end
			managers.game_play_central:do_shotgun_push( character_unit, col_ray.position, col_ray.ray, feet and 2 or 1)
			if shield then
				managers.explosion:units_to_push({shield}, col_ray.position, 10000)
			end
			return defense_data
		end
	end
	
	return col_ray
end
function PlayerStandard:goat_attack_head(t, input, feet)
	self._state_data.meleeing = true
	self._state_data.melee_feet = feet
	self._state_data.melee_damage_delay_t = t + (feet and 0.4 or 0.25)
	self._state_data.melee_repeat_expire_t = t + (feet and 1 or 0.5)
	self:goat_play_anim(feet and "anim_attack_feet" or "anim_attack_head", t)
end
function PlayerStandard:_update_melee_timers(t, input)
	if self._state_data.melee_damage_delay_t and t >= self._state_data.melee_damage_delay_t then
		self:goat_attack_damage(t)
		self._state_data.melee_damage_delay_t = nil
	end
	if self._state_data.melee_repeat_expire_t and t >= self._state_data.melee_repeat_expire_t then
		self._state_data.melee_repeat_expire_t = nil
	end
end
function PlayerStandard:_check_action_primary_attack(t, input)
	local action_wanted = input.btn_primary_attack_state
	if not action_wanted then
		return
	end
	local action_forbidden = not self:_melee_repeat_allowed() or self:_interacting() or self:_is_throwing_projectile()
	if action_forbidden then
		return
	end
	local feet = self:goat_get_move_dir() == "b"
	self:goat_attack_head(t, input, feet)
	return true
end
--lick
function PlayerStandard:goat_lick(t, input)
	if not managers.player.goat:unit_alive() then
		return
	end
	if managers.player.goat:grabbing() then
		managers.player.goat:drop()
		return
	end
	
	local from = managers.viewport:get_current_camera():position()
	local to = from + managers.viewport:get_current_camera():rotation():y() * 10000
	local col_ray = self._unit:raycast("ray", from, to, "slot_mask", self._slotmask_bullet_impact_targets, "ignore_unit", managers.player.goat:unit())
	if col_ray then
		local from = managers.player.goat:unit():position() + Goat.HEIGHT
		local pos = col_ray.position
		if mvector3.distance(from, col_ray.position) < Goat.TONGUE_MLENGTH then
			managers.player.goat:grab(col_ray)
			managers.game_play_central:play_impact_sound_and_effects({
				col_ray = col_ray,
				no_decal = true,
				no_sound = true
			})
		end
	end
end
function PlayerStandard:_check_action_melee(t, input)
	local action_wanted = input.btn_melee_press
	if not action_wanted then
		return
	end
	local action_forbidden = self:_is_throwing_projectile()
	if action_forbidden then
		return
	end
	self:goat_lick(t, input)
	return true
end
--ragdoll
function PlayerStandard:_check_action_weapon_gadget(t, input)
	local new_action
	local action_wanted = input.btn_weapon_gadget_press
	if action_wanted then
		local action_forbidden = self:_is_meleeing()
		if not action_forbidden then
			managers.player.goat:switch_ragdoll_vel()
		end
	end
	return new_action
end
--yell
function PlayerStandard:_check_action_equip(t, input)
	local new_action
	local selection_wanted = input.btn_primary_choice
	if selection_wanted == 1 and (not self._goat_baah_t or self._goat_baah_t < t) then
		self:goat_play_anim("anim_yell_baah", t)
		self._goat_baah_t = t + 2
	end
	return new_action
end
